
class Link:

   def __init__(self):
       self.filterFrom = None # should be of type Filter
       self.filterTo = None   # should be of type ParametrizedFilter
       self.label = "reminds-me-of"
                  
   def connects(self, entry1, entry2):
       """
       Returns true if this link connects the two entries involved
       """
       if not self.filterFrom.matches(entry1):
           return 0
       self.filterTo.setParameterEntry(entry1)
       if not self.filterTo.matches(entry2):
           return 0
       return 1
       
   def getConnections(self, metadata):
       """
         Returns a list of pairs, the entries connected by this link
       """
       connections = []
       for a in metadata.entries:
           if not self.filterFrom.matches(a):
               continue
           for b in metadata.entries:
               if self.connects(a, b):
                   connections.append((a, b))
       return connections
                   
   def printLink(self, metadata):
       print self.label 
       connections = self.getConnections(metadata)
       for pair in connections:
           print pair[0].getProperty("title") + " ----> " + pair[1].getProperty("title")
