import string
import traceback
import os.path
import kraken.Constants as Constants
import FieldHelper
import Presentation


def createEntryPage(entry):
  try:
    #print entry
    htmlFile = os.path.join(entry.getAbsoluteDirName(), 
                            Constants.DIRNAME_METADATA,
                            Constants.FILENAME_ENTRY_HTML)
    t = Presentation.htmlBegin()
    t += entryPageHeader(entry)
    
    entryTypes = entry.getProperty("entryTypes")
    if "Article" in entryTypes:
        print "Generate article " + htmlFile
        t += generateArticle(entry)
    
    # temporary simplified
    for name in entry.listExtendedPropertyNames():
        t += "<p><b>" + name + " =</b>" + str(entry.getExtendedProperty(name)) + "\n"     
    t += Presentation.htmlEnd()
    OUTPUTFILE = open(htmlFile, "w")
    OUTPUTFILE.write(t)
    OUTPUTFILE.close()
    #if string.find(htmlFile, ".kraken") != -1:
    #    print "Done" + htmlFile
  except:
    traceback.print_exc()

def entryPageHeader(entry):
    temp = ""
    temp +='<table style="background: gray;" cols=2 width="100%" cellspacing="0">\n'
    temp += '<tr><td width="20%" style="background: black; color: white; font-family: sans-serif;">'
    for a in entry.getProperty("entryTypes"):
       temp += "<h2>" + a + "</h2><br/>\n"    
    temp += "</td><td>\n"    
    temp += "<h1>" + entry.getProperty("title") + "</h1>\n"
    temp += FieldHelper.paragraphField(entry, "description")    
    temp += FieldHelper.paragraphField(entry, "date")    
    temp += "</td></tr></table>\n"
    return temp
    
def generateArticle(entry):
    #print "generateArticle"
    return entryBibTexHtml(entry)    
    
def entryBibTexHtml(entry):    
    #print "Here we are"
    # FIXME: there is some exception here.
    bibtype = entry.getExtendedProperty("BibTex.type")
    if bibtype == None:
        bibtype = "unknown"
    bibtype = string.lower(bibtype)
    temp ='<table style="background: yellow;" cols=2 width="100%" cellspacing="0">\n'
    temp += '<tr><td style="font-family: sans-serif;">'
    temp += "<h1>" + string.capitalize(bibtype) + "</h1>"
    if bibtype == "article":
      temp += FieldHelper.paragraphField(entry, "BibTex.author")
      temp += FieldHelper.paragraphField(entry, "BibTex.title")
      temp += FieldHelper.paragraphField(entry, "BibTex.journal")
      temp += FieldHelper.paragraphField(entry, "BibTex.volume")
      temp += FieldHelper.paragraphField(entry, "BibTex.month")
      temp += FieldHelper.paragraphField(entry, "BibTex.year")      
    elif bibtype == "inproceedings":
      temp += FieldHelper.paragraphField(entry, "BibTex.author")
      temp += FieldHelper.paragraphField(entry, "BibTex.title")
      temp += FieldHelper.paragraphField(entry, "BibTex.booktitle")
      temp += FieldHelper.paragraphField(entry, "BibTex.month")
      temp += FieldHelper.paragraphField(entry, "BibTex.year")      
    else:
      temp += "<p>No formatting for this type yet.</p>"
    temp += "</td>\n</tr>\n</table>\n"
    #print temp
    return temp
